#
# spec file for package x3270 (Version 3.2.16)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  tcl tcl-devel tclx xf86
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit tcl tcl-devel tclx texinfo textutils timezone unzip util-linux vim xdevel xf86 xshared

Name:         x3270
Copyright:    Paul Mattes (Paul.Mattes@usa.net), Jeff Sparkes (jsparkes@bnr.ca), Robert Viduya
Group:        X11/Terminals
Provides:     x3270 
Autoreqprov:  on
Version:      3.2.16
Release:      114
Summary:      Family of IBM 3270 terminal emulators
URL:          http://x3270.bgp.nu
Source:       http://x3270.bgp.nu/download/x3270-3217.tgz  
Source1:      http://x3270.bgp.nu/download/c3270-3217.tgz  
Source2:      http://x3270.bgp.nu/download/pr3287-3217.tgz 
Source3:      http://x3270.bgp.nu/download/s3270-3217.tgz  
Source4:      http://x3270.bgp.nu/download/tcl3270-3217.tgz
Patch:        mknod.patch
Patch1:       http://x3270.bgp.nu/download/x3270-3.2.17-1.txt
Patch2:       http://x3270.bgp.nu/download/c3270-3.2.17-1.txt
Patch3:       http://x3270.bgp.nu/download/s3270-3.2.17-1.txt
Patch4:       http://x3270.bgp.nu/download/tcl3270-3.2.17-1.txt
Patch5:       http://x3270.bgp.nu/download/pr3287-3.2.17-1.txt
Patch6:       http://x3270.bgp.nu/download/x3270-3.2.17-2.txt
Patch7:       http://x3270.bgp.nu/download/pr3287-3.2.17-2.txt
Patch8:       usr_local_bin.patch
Group:        X11/Terminals
BuildRoot:    %{_tmppath}/%{name}-buildroot

%description
This package contains a family of 3270 mainframe terminal emulators:
* terminal emulators for interactive use
x3270  X Window System
c3270  curses based
* terminal emulators for scripted use
s3270    see x3270-script man page
tcl3270  tcl based
* printer emulator pr3287
x3270 is an IBM 3270 terminal emulator for the X Window System.  x3270
runs over a TELNET connection (with or without TN3270E) and emulates
either an IBM 3279 (color) or 3278 (monochrome).  It supports APL2
characters, IND$FILE file transfer, NVT mode, a pop-up keypad for
3270-specific keys, alternative keymaps, 3287 printer sessions, a
scrollbar and has extensive debugging and scripting facilities.
c3270 is the curses-based version of x3270.  It runs on any dumb
terminal (e.g. xterm, console), and supports (almost) all of the
features of x3270.  c3270 scripts are compatible with x3270 scripts,
and the subset of command-line options and resource definitions are
compatible as well.
s3270 is a scripting-only version of x3270.  This program is intended
primarily for writing "screen-scraping" applications, e.g., a CGI
back-end script that retrieves database information from a mainframe.
tcl3270 is a Tcl-based 3270 scripting engine.  It lets you write Tcl
scripts that manipulate 3270 sessions, and is quite a bit easier to
set up and use than s3270.
pr3287 is the printer companion for the tools above, and allows
printer output from a 3270 session to be directed to a Unix printer
queue.

Authors:
--------
    Paul Mattes <pdm@cnt.com>

SuSE series: xap

%prep
# the source-packages all extract to corresponding subdirectories.
# they are all expanded below a 'all3270' directory.  this directory
# will also hold the common config.cache
# -q uietly -c reate -n ame all3270
# -a fter changing into all3270, expand sources
%setup -q -c -n all3270 -a1 -a2 -a3 -a4
%patch
%patch8
cd x3270-3.2
%patch1
cd ../c3270-3.2
%patch2
cd ../s3270-3.2
%patch3
cd ../tcl3270-3.2
%patch4
cd ../pr3287-3.2
%patch5
cd ../x3270-3.2
%patch6
cd ../pr3287-3.2
%patch7

%build
export CFLAGS="$RPM_BUILD_OPT"
export LIBX3270DIR=/etc/x3270
# the X variant
cd x3270-3.2
    %{?suse_update_config:%{suse_update_config -f .}}
    # pr3287 is built from the separate source pr3287*.tgz above.
    ./configure \
	--cache-file=../config.cache \
	--prefix=%{_prefix} \
	--enable-app-defaults \
	--without-pr3287
    xmkmf -a
    make depend
    make LIBX3270DIR=${LIBX3270DIR}
cd ..
# the console variant
cd c3270-3.2
    %{?suse_update_config:%{suse_update_config -f .}}
    ./configure \
	--cache-file=../config.cache \
	--bindir=%{_bindir} \
	--prefix=%{_prefix} \
	--mandir=%{_mandir} \
	--without-pr3287
    make LIBX3270DIR=${LIBX3270DIR}
cd ..
# the scripting variant
cd s3270-3.2
    %{?suse_update_config:%{suse_update_config -f .}}
    ./configure \
	--cache-file=../config.cache \
	--bindir=%{_bindir} \
	--prefix=%{_prefix} \
	--mandir=%{_mandir}
    make LIBX3270DIR=${LIBX3270DIR}
cd ..
# the tcl variant
cd tcl3270-3.2
    %{?suse_update_config:%{suse_update_config -f .}}
    ./configure \
	--cache-file=../config.cache \
	--bindir=%{_bindir} \
	--prefix=%{_prefix} \
	--mandir=%{_mandir} \
	--with-tclx
    make LIBX3270DIR=${LIBX3270DIR}
cd ..
# the printer
cd pr3287-3.2
    %{?suse_update_config:%{suse_update_config -f .}}
    ./configure \
	--cache-file=../config.cache \
	--bindir=%{_bindir} \
	--prefix=%{_prefix} \
	--mandir=%{_mandir}
    make LIBX3270DIR=${LIBX3270DIR}
cd ..

%install
export LIBX3270DIR=/etc/x3270
# abort on error
set -e
# if RPM_BUILD_ROOT is set, clean it up
${RPM_BUILD_ROOT:+rm -rf $RPM_BUILD_ROOT}
# create the default directory structure in the build root
mkdir --parents $RPM_BUILD_ROOT{/usr/bin,%{_mandir}/{man1,man5}}
# the X variant
cd x3270-3.2
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install.man
    # make install does a mkfontdir, that creates a fonts.dir we don't
    # want in the package.  remove that:
    rm $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc/fonts.dir
    install -d -g root -o root -m 755 \
	$RPM_BUILD_ROOT/usr/X11R6/lib/X11/app-defaults
    install -g root -o root -m 644 X3270.xad \
	$RPM_BUILD_ROOT/usr/X11R6/lib/X11/app-defaults/X3270
    # clean up:
    # remove remainders of patching the examples
    rm Examples/*.orig
cd ..
# the console variant
cd c3270-3.2
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install.man
cd ..
# the scripting variant
cd s3270-3.2
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install.man
cd ..
# the tcl variant
cd tcl3270-3.2
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install.man
cd ..
# the printer
cd pr3287-3.2
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install
    make DESTDIR=$RPM_BUILD_ROOT LIBX3270DIR=${LIBX3270DIR} install.man
cd ..
# move site config files to the standard locations
mkdir -p $RPM_BUILD_ROOT/usr/etc/x3270
mkdir -p $RPM_BUILD_ROOT/usr/lib/x3270
# this is a per-site, not a per-machine config file
mv $RPM_BUILD_ROOT/etc/x3270/ibm_hosts $RPM_BUILD_ROOT/usr/etc/x3270/ibm_hosts
ln -snf     ../../usr/etc/x3270/ibm_hosts $RPM_BUILD_ROOT/etc/x3270/ibm_hosts
# this directory and its contents should be R/O
mv $RPM_BUILD_ROOT/etc/x3270/charset $RPM_BUILD_ROOT/usr/lib/x3270/charset
ln -snf  ../../usr/lib/x3270/charset  $RPM_BUILD_ROOT/etc/x3270/charset

%clean
#${RPM_BUILD_ROOT:+rm -rf $RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
# common files
%config /usr/etc/x3270/ibm_hosts
%config /etc/x3270/ibm_hosts
/etc/x3270/charset
/usr/lib/x3270/charset
%doc /usr/share/man/man5/ibm_hosts.5.gz
%doc /usr/share/man/man1/x3270if.1.gz
%doc /usr/share/man/man1/x3270-script.1.gz
/usr/bin/x3270if
# x3270
/usr/X11R6/bin/x3270
%config /usr/X11R6/lib/X11/app-defaults/X3270
/usr/X11R6/lib/X11/fonts
%doc /usr/X11R6/man/man1/x3270.1x.gz
%doc --parents x3270-3.2/Examples
%doc --parents x3270-3.2/html
%doc --parents x3270-3.2/Playback
# c3270
/usr/bin/c3270
%doc /usr/share/man/man1/c3270.1.gz
%doc --parents c3270-3.2/html
# pr3287
/usr/bin/pr3287
%doc /usr/share/man/man1/pr3287.1.gz
%doc --parents pr3287-3.2/html
# s3270
/usr/bin/s3270
%doc /usr/share/man/man1/s3270.1.gz
%doc --parents s3270-3.2/Examples
%doc --parents s3270-3.2/html
# tcl3270
/usr/bin/tcl3270
%doc /usr/share/man/man1/tcl3270.1.gz
%doc --parents tcl3270-3.2/Examples
%doc --parents tcl3270-3.2/html

%post 
echo "Updating fonts.dir ..."
if [ -x usr/X11R6/bin/mkfontdir ] ; then
  # This should hopefully run mkfontdir right:
  # In case ldconfig is not run in the chroot yet(during installation):
  export LD_LIBRARY_PATH=/usr/X11R6/lib
  # If xshared is not in the instsys: x3270 needs xshared installed anyway:
  chroot . /usr/X11R6/bin/mkfontdir /usr/X11R6/lib/X11/fonts/misc
  # (and it was also in question if "/usr/X11R6/lib..." would be the right
  #  path when installing with yast1)
  # usr/X11R6/bin/xset fp rehash
else
  echo "ERROR: mkfontdir not found. This should not happen. Please rehash"
  echo "/usr/X11R6/lib/X11/fonts/misc by hand."
fi

%postun
echo "Updating fonts.dir ..."
if [ -x usr/X11R6/bin/mkfontdir ] ; then
  # This should hopefully run mkfontdir right:
  # In case ldconfig is not run in the chroot yet(during installation):
  export LD_LIBRARY_PATH=/usr/X11R6/lib
  # If xshared is not in the instsys: x3270 needs xshared installed anyway:
  chroot . /usr/X11R6/bin/mkfontdir /usr/X11R6/lib/X11/fonts/misc
  # (and it was also in question if "/usr/X11R6/lib..." would be the right
  #  path when installing with yast1)
  # usr/X11R6/bin/xset fp rehash
else
  echo "ERROR: mkfontdir not found. This should not happen. Please rehash"
  echo "/usr/X11R6/lib/X11/fonts/misc by hand."
fi

%changelog -n x3270
* Mon Jul 30 2001 - froh@suse.de
- patched /usr/local/bin to /usr/bin in a new expect script below
  s3270/Examples/* and checked that no /usr/local are left :)
* Wed Jul 25 2001 - froh@suse.de
- patched away /usr/local/bin in a new shell script below
  x3270/Examples/*
* Tue Jul 24 2001 - froh@suse.de
- upgraded to current release 3.2.17 + current bugfixes
* Wed Mar 28 2001 - froh@suse.de
- use 'size_t' consistently instead of 'unsigned' to make pr3278 build
  on axp (use-size_t.diff)
* Wed Mar 28 2001 - froh@suse.de
- upgraded to current version 3.2.16
- added c3270, tcl3270, s3270 and made them coexist with each other
  (common config file, shared helpers)
* Thu Nov 30 2000 - fober@suse.de
- upgraded to current version 3.2.14
- adopted to current FHS
- introduced BuildRoot to clean up %%files-section
* Fri Oct 27 2000 - fober@suse.de
- fixed calling of mkfontdir(needs chroot if no xshared in instsys) in
  %%postun as well
* Mon Oct 09 2000 - bk@suse.de
- fixed calling of mkfontdir(needs chroot if no xshared in instsys) in
  %%postin
* Wed Jun 07 2000 - ro@suse.de
- fixed path for mkfontdir
* Tue Feb 01 2000 - mkraft@suse.de
- updated to new (alpha) version 3.2, some changes to spec file
- pre- and postinstall scripts to rebuild fonts.dir
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Mar 17 1999 - ro@suse.de
- remove .orig with -f
* Sat Sep 19 1998 - ro@suse.de
- dont redeclare sys_errlist for glibc
* Thu Jul 23 1998 - werner@suse.de
- Check exit status of mknod in peer_script.(ba)sh
* Mon Nov 17 1997 - ro@suse.de
- changes /usr/local/bin/expect to /usr/bin/expect
  and /bin/ksh to /usr/bin/ksh
* Mon Oct 13 1997 - hf@suse.de
- ready for autobuild
* Fri Jun 06 1997 - bs@suse.de
- removed usr/X11R6/lib/X11/fonts/misc/fonts.dir
* Mon Jun 02 1997 - hf@suse.de
  Added the x3270 app-defaults file.
* Wed May 21 1997 - hf@suse.de
  A new version 3.1.1.6
  x3270 is an IBM 3278/3279 terminal emulator for X windows.
